# Odo changelog #

## Unreleased

## v0.5.0 - Unreleased

### Added

+ State plan episodes are now differentiated as either goal or value episodes.

+ Began McCLIM integration with Odo. This is highly experimental and will
  likely change quite a bit before it is stabilized.
  
+ Binary Decision Diagrams (BDDs) now supported.

+ `deserialize` generic function dispatches to the correct `deserialize-from-*`
  function based on the type of the first argument (stream, string, or
  pathname).
  
+ `deserialize-from-*` can now return a state plan from minizinc or flatzinc
  sources.

+ minizinc: Added `uncontrollable_var` annotation.

+ minizinc: Added `episode` predicate.

+ minizinc: Added `contingent` annotation.

+ Added `LOOPING-SIMPLE-TEMPORAL` predicate.

### Changed

+ The ability to (de)serialize episode temporal constraints as expressions was
removed. We changed it to always be constraints.

+ Dependency on cl-mathstats removed.

+ Odo packages are no longer locked. This made portability harder, as well as
  some types of interactive editing. Users of Odo should make sure to prefix
  all odo symbols with `odo:`. Do *not* `:use` `:odo`. This will obviate the
  need for package locks in most cases, plus prevent future breakage in case
  odo defines a symbol in a future release that conflicts with something in
  your package.
  
+ Changed the minizinc to flatzinc compiler from the deprecated `mzn2fzn`
  executable to the default `minizinc` with the `mzn-fzn` solver.
  
+ minizinc: signature for stc predicate has changed.

+ minizinc: parses stc (and reifed versions) as `SIMPLE-TEMPORAL` instead of
  conjunction of inequalities.

### Deprecated

+ The `ODO/SHADOWS` package has been deprecated. The same symbols are now
  present in and exported from the `ODO`package, except for
  `=`. `ODO/SHADOWS:=` remains a deprecated nickname for `ODO:EQUAL`.
+ The following functions have been deprecated.
  + `ADD-AUTOMATON-INTERFACE-VARIABLE!` -> `ADD-INTERFACE-VARIABLE!`
  + `ADD-AUTOMATON-LOCATION!` -> `ADD-LOCATION!`
  + `ADD-AUTOMATON-STATE-VARIABLE!` -> `ADD-STATE-VARIABLE!`
  + `ADD-AUTOMATON-TRANSITION!` -> `ADD-TRANSITION!`
  + `ADD-EPISODE!` -> `ADD-GOAL-EPISODE!`
  + `ADD-LOCATION-CONSTRAINT!` -> `ADD-STATE-CONSTRAINT!`
  + `ADD-STATE-PLAN-CHANCE-CONSTRAINT!` -> `ADD-CHANCE-CONSTRAINT!`
  + `APPLICATION-ARGUMENT-VALUE` -> `ARGUMENT-VALUE`
  + `APPLICATION-ARGUMENT-VALUE-BY-TYPE` -> `ARGUMENT-VALUE-BY-TYPE`
  + `APPLICATION-ARGUMENTS` -> `ARGUMENTS`
  + `APPLICATION-OPERATOR` -> `OPERATOR` (see doc string for some additional changes)
  + `ATTRIBUTE-OBJECTIVE-ATTRIBUTE-VALUES-ALIST` -> `ATTRIBUTE-VALUES-ALIST`
  + `AUTOMATON-CLOCK-PARAMETERS` -> `CLOCK-PARAMETERS`
  + `AUTOMATON-CLOCK-VARIABLES` -> `CLOCK-VARIABLES`
  + `AUTOMATON-INTERFACE-VARIABLES` -> `INTERFACE-VARIABLES`
  + `AUTOMATON-LOCATION-VARIABLE` -> `LOCATION-VARIABLE`
  + `AUTOMATON-LOCATIONS` -> `LOCATIONs`
  + `AUTOMATON-NAME` -> `NAME`
  + `AUTOMATON-STATE-VARIABLES` -> `STATE-VARIABLES`
  + `AUTOMATON-TRANSITIONS` -> `TRANSITIONS`
  + `BRANCH-PROBABILITY` -> `PROBABILITY`
  + `BRANCH-TARGET` -> `TARGET`
  + `CC-CONSTRAINT-ITERATOR` -> `CONSTRAINT-ITERATOR`
  + `CC-CONSTRAINT-LIST` -> `CONSTRAINT-LIST`
  + `CC-FAILURE-PROBABILITY` -> `FAILURE-PROBABILITY`
  + `CC-NAME` -> `NAME`
  + `CONSTRAINT-EXPRESSION` -> `EXPRESSION`
  + `CONSTRAINT-NAME` -> `NAME`
  + `CSP-STATE-SPACE` -> `STATE-SPACE`
  + `EPISODE-ACTIVITY-ARGS` -> `ACTIVITY-ARGS`
  + `EPISODE-ACTIVITY-NAME` -> `ACTIVITY-NAME`
  + `EPISODE-CONDITIONAL-P` -> `CONDITIONAL-P`
  + `EPISODE-END-CONSTRAINTS` -> `END-CONSTRAINTS`
  + `EPISODE-END-EVENT` -> `END-EVENT`
  + `EPISODE-NAME` -> `NAME`
  + `EPISODE-ONCE-CONSTRAINTS` -> `ONCE-CONSTRAINTS`
  + `EPISODE-OVER-ALL-CONSTRAINTS` -> `OVER-ALL-CONSTRAINTS`
  + `EPISODE-START-CONSTRAINTS` -> `START-CONSTRAINTS`
  + `EPISODE-START-EVENT` -> `START-EVENT`
  + `EPISODE-TEMPORAL-CONSTRAINT` -> `TEMPORAL-CONSTRAINT`
  + `EVENT-CONDITIONAL-P` -> `CONDITIONAL-P`
  + `EVENT-DELAYED-P` -> `DELAYED-P`
  + `EVENT-NAME` -> `NAME`
  + `EVENT-OBSERVATIONS` -> `OBSERVATIONS`
  + `EVENT-UNCONTROLLABLE-P` -> `UNCONTROLLABLE-P`
  + `EXPRESSION-BOUNDS` -> `BOUNDS`
  + `EXPRESSION-BOUNDS-BY-TYPE` -> `BOUNDS-BY-TYPE`
  + `EXPRESSION-DERIVATIVE` -> `DERIVATIVE`
  + `EXPRESSION-DERIVATIVE-BY-TYPE` -> `DERIVATIVE-BY-TYPE`
  + `EXPRESSION-SCOPE` -> `SCOPE`
  + `EXPRESSION-SCOPE-BY-TYPE` -> `SCOPE-BY-TYPE`
  + `GET-AUTOMATON-INTERFACE-VARIABLE` -> `GET-INTERFACE-VARIABLE`
  + `GET-AUTOMATON-LOCATION` -> `GET-LOCATION`
  + `GET-AUTOMATON-STATE-VARIABLE` -> `GET-STATE-VARIABLE`
  + `GET-AUTOMATON-TRANSITION` -> `GET-TRANSITION`
  + `LOCATION-CONSTRAINTS` -> `STATE-CONSTRAINT-LIST`
  + `LOCATION-INCOMING-TRANSITIONS` -> `INCOMING-TRANSITIONS`
  + `LOCATION-OUTGOING-TRANSITIONS` -> `OUTGOING-TRANSITIONS`
  + `LOCATION-NAME` -> `NAME`
  + `ODO-*` -> `*`
  + `ODO-+` -> `+`
  + `ODO--` -> `-`
  + `ODO-/` -> `/`
  + `ODO-=` -> `=`
  + `ODO-AND` -> `AND`
  + `ODO-APPLICATION-EXPRESSION` -> `APPLICATION-EXPRESSION`
  + `ODO-APPLICATION-EXPRESSION-P` -> `APPLICATION-EXPRESSION-P`
  + `ODO-ATTRIBUTE-OBJECTIVE-FUNCTION` -> `ATTRIBUTE-OBJECTIVE-FUNCTION`
  + `ODO-AUTOMATON` -> `AUTOMATON`
  + `ODO-AUTOMATON-TRANSITION` -> `AUTOMATON-TRANSITION`
  + `ODO-AUTOMATON-TRANSITION-BRANCH` -> `AUTOMATON-TRANSITION-BRANCH`
  + `ODO-CHANCE-CONSTRAINT` -> `CHANCE-CONSTRAINT`
  + `ODO-CHANCE-CONSTRAINT-P` -> `CHANCE-CONSTRAINT-P`
  + `ODO-CONCURRENT-AUTOMATON` -> `CONCURRENT-AUTOMATON`
  + `ODO-CONDITIONAL-EVENT` -> `CONDITIONAL-EVENT`
  + `ODO-CONDITIONAL-P` -> `CONDITIONAL-P`
  + `ODO-CONDITIONAL-VARIABLE` -> `CONDITIONAL-VARIABLE`
  + `ODO-CONDITIONAL-VARIABLE-P` -> `CONDITIONAL-VARIABLE-P`
  + `ODO-CONSTRAINT` -> `CONSTRAINT`
  + `ODO-CONSTRAINT-P` -> `CONSTRAINT-P`
  + `ODO-CONTINGENT-CONSTRAINT` -> `CONTINGENT-CONSTRAINT`
  + `ODO-CONTROLLABLE-CONDITIONAL-EVENT` -> `CONTROLLABLE-CONDITIONAL-EVENT`
  + `ODO-CONTROLLABLE-CONDITIONAL-VARIABLE` -> `CONTROLLABLE-CONDITIONAL-VARIABLE`
  + `ODO-CONTROLLABLE-EVENT` -> `CONTROLLABLE-EVENT`
  + `ODO-CONTROLLABLE-VARIABLE` -> `CONTROLLABLE-VARIABLE`
  + `ODO-COPY` -> `COPY`
  + `ODO-COPY-BY-TYPE` -> `COPY-BY-TYPE`
  + `ODO-CSP` -> `CSP`
  + `ODO-CSP-P` -> `CSP-P`
  + `ODO-DOMAIN` -> `DOMAIN`
  + `ODO-DOMAIN-P` -> `DOMAIN-P`
  + `ODO-EPISODE` -> `EPISODE`
  + `ODO-EPISODE-P` -> `EPISODE-P`
  + `ODO-EQUAL` -> `EQUAL`
  + `ODO-EQUAL-P` -> `EQUAL-P`
  + `ODO-EQUAL-P-BY-TYPE` -> `EQUAL-P-BY-TYPE`
  + `ODO-EVENT` -> `EVENT`
  + `ODO-EVENT-P` -> `EVENT-P`
  + `ODO-EXPRESSION` -> `EXPRESSION`
  + `ODO-EXPRESSION-P` -> `EXPRESSION-P`
  + `ODO-FUNCALL` -> `FUNCALL`
  + `ODO-HIERARCHICAL-AUTOMATON` -> `HIERARCHICAL-AUTOMATON`
  + `ODO-HIERARCHICAL-AUTOMATON-ALL` -> `HIERARCHICAL-AUTOMATON-ALL`
  + `ODO-HIERARCHICAL-AUTOMATON-XOR` -> `HIERARCHICAL-AUTOMATON-XOR`
  + `ODO-LOOKUP-EXPRESSION` -> `LOOKUP-EXPRESSION`
  + `ODO-MAKE-INSTANCE` -> `MAKE-INSTANCE`
  + `ODO-NEGATIVE-INFINITY` -> `NEGATIVE-INFINITY`
  + `ODO-NOT` -> `NOT`
  + `ODO-OBJECT` -> `OBJECT`
  + `ODO-OR` -> `OR`
  + `ODO-PRIMITIVE-AUTOMATON` -> `PRIMITIVE-AUTOMATON`
  + `ODO-PRIMITIVE-LOCATION` -> `PRIMITIVE-LOCATION`
  + `ODO-POSITIVE-INFINITY` -> `POSITIVE-INFINITY`
  + `ODO-STATE-CONSTRAINT` -> `STATE-CONSTRAINT`
  + `ODO-STATE-CONSTRAINT-P` -> `STATE-CONSTRAINT-P`
  + `ODO-STATE-PLAN` -> `STATE-PLAN`
  + `ODO-STATE-PLAN-P` -> `STATE-PLAN-P`
  + `ODO-STATE-SPACE` -> `STATE-SPACE`
  + `ODO-STATE-SPACE-P` -> `STATE-SPACE-P`
  + `ODO-STATE-VARIABLE` -> `STATE-VARIABLE`
  + `ODO-STATE-VARIABLE-P` -> `STATE-VARIABLE-P`
  + `ODO-TRANSFORM` -> `TRANSFORM`
  + `ODO-TRANSITION-CONSTRAINT` -> `TRANSITION-CONSTRAINT`
  + `ODO-TRANSITION-CONSTRAINT-P` -> `TRANSITION-CONSTRAINT-P`
  + `ODO-TYPE` -> `TYPE`
  + `ODO-TYPE-P` -> `TYPE-P`
  + `ODO-UNCONTROLLABLE-CONDITIONAL-EVENT` -> `UNCONTROLLABLE-CONDITIONAL-EVENT`
  + `ODO-UNCONTROLLABLE-CONDITIONAL-VARIABLE` -> `UNCONTROLLABLE-CONDITIONAL-VARIABLE`
  + `ODO-UNCONTROLLABLE-DELAYED-EVENT` -> `UNCONTROLLABLE-DELAYED-EVENT`
  + `ODO-UNCONTROLLABLE-EVENT` -> `UNCONTROLLABLE-EVENT`
  + `ODO-UNCONTROLLABLE-VARIABLE` -> `UNCONTROLLABLE-VARIABLE`
  + `ODO-VARIABLE` -> `VARIABLE`
  + `ODO-VARIABLE-P` -> `VARIABLE-P`
  + `ODO-XOR` -> `XOR`
  + `PDDL-ACTION-CONDITION` -> `CONDITION`
  + `PDDL-ACTION-EFFECT` -> `EFFECT`
  + `PDDL-ACTION-NAME` -> `NAME`
  + `PDDL-CONSTANT-NAME` -> `NAME`
  + `PDDL-CONTROL-VARIABLE-BOUNDS` -> `BOUNDS`
  + `PDDL-CONTROL-VARIABLE-NAME` -> `NAME`
  + `PDDL-DOMAIN-NAME` -> `NAME`
  + `PDDL-FUNCTION-NAME` -> `NAME`
  + `PDDL-PARAMETER-NAME` -> `NAME`
  + `PDDL-PREDICATE-NAME` -> `NAME`
  + `PDDL-TYPE-NAME` -> `NAME`
  + `PDDL-TYPE-SUPERTYPE` -> `SUPERTYPE`
  + `PRIMITIVE-LOCATION-NAME` -> `NAME`
  + `READ-CSP-FROM-FILE` -> `DESERIALIZE-FROM-FILE`
  + `REMOVE-AUTOMATON-INTERFACE-VARIABLE!` -> `REMOVE-INTERFACE-VARIABLE!`
  + `REMOVE-AUTOMATON-TRANSITION!` -> `REMOVE-TRANSITION!`
  + `REMOVE-LOCATION-CONSTRAINT!` -> `REMOVE-STATE-CONSTRAINT!`
  + `STATE-PLAN-CHANCE-CONSTRAINT-ITERATOR` -> `CHANCE-CONSTRAINT-ITERATOR`
  + `STATE-PLAN-CHANCE-CONSTRAINT-LIST` -> `CHANCE-CONSTRAINT-LIST`
  + `STATE-PLAN-CONSTRAINT-ITERATOR` -> `CONSTRAINT-ITERATOR`
  + `STATE-PLAN-CONSTRAINT-LIST` -> `CONSTRAINT-LIST`
  + `STATE-PLAN-EPISODE-ITERATOR` -> `GOAL-EPISODE-ITERATOR`
  + `STATE-PLAN-EPISODE-LIST` -> `GOAL-EPISODE-LIST`
  + `STATE-PLAN-EVENT-ITERATOR` -> `STATE-PLAN-EVENT-ITERATOR`
  + `STATE-PLAN-EVENT-LIST` -> `STATE-PLAN-EVENT-LIST`
  + `STATE-PLAN-FEATURES` -> `FEATURES`
  + `STATE-PLAN-NAME` -> `NAME`
  + `STATE-PLAN-OBJECTIVE` -> `OBJECTIVE`
  + `STATE-PLAN-START-EVENT` -> `START-EVENT`
  + `STATE-PLAN-STATE-SPACE` -> `STATE-SPACE`
  + `STATE-VARIABLE-CONDITIONAL-P` -> `CONDITIONAL-P`
  + `STATE-VARIABLE-NAME` -> `NAME`
  + `STATE-VARIABLE-RANGE` -> `RANGE`
  + `STATE-VARIABLE-RANGE-AT` -> `RANGE-AT`
  + `STATE-VARIABLE-UNCONTROLLABLE-P` -> `UNCONTROLLABLE-P`
  + `TRANSITION-BRANCHES` -> `BRANCHES`
  + `TRANSITION-CLOCK-RESETS` -> `CLOCK-RESETS`
  + `TRANSITION-GUARD` -> `GUARD`
  + `TRANSITION-NAME` -> `NAME`
  + `TRANSITION-SOURCE` -> `SOURCE`
  + `VARIABLE-NAME` -> `NAME`

### Removed

+ The following deprecated functions have been removed:
  + `ADD-DOMAIN!`
  + `ADD-VARIABLE!`
  + `ADD-VARIABLE-GROUP!`
  + `CONDITIONAL-VARIABLE-EQUAL`
  + `DOMAIN-ITERATOR`
  + `DOMAIN-LIST`
  + `GET-DOMAIN`
  + `GET-VARIABLE`
  + `GET-VARIABLE-GROUP`
  + `STATE-SPACE-EQUAL`
  + `VARIABLE-EQUAL`
  + `VARIABLE-ITERATOR`
  + `VARIABLE-LIST`

## v0.4.0 - November 9, 2020

Unfortunately, this changelog is woefully incomplete. We'll try to do a better
job going forward at updating at as changes are added.

### Added

+ PDDL domain support
+ Implemented `REMOVE-CONSTRAINT!` for state plans
+ Implemented `GET-CONSTRAINT` for state plans

### Deprecations

+ A number of functions have been deprecated and are slated for removal in
  v0.5. They will currently produce style warnings when calls to them are
  compiled, and when they are called for the first time.


## v0.3.2 - February 6, 2019

+ Fixed issues with flatzinc parser erroring on spaces around commas (#98) and
  enumerated integer domains (#99).
+ Added support for conditional variables. Conditional variables are activated
  through the VARIABLE-ACTIVE predicate.
+ Many more fixes we weren't diligent about adding to the changelog.

## v0.3.0 - February 26, 2018

First officially released version.
